'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _draftJs = require('draft-js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DEFAULT_TOOLBAR_HEIGHT = 44;

var getRelativeParent = function getRelativeParent(element) {
  if (!element) {
    return null;
  }

  var position = window.getComputedStyle(element).getPropertyValue('position');
  if (position !== 'static') {
    return element;
  }

  return getRelativeParent(element.parentElement);
};

var DefaultToolbarComponent = function DefaultToolbarComponent(_ref) {
  var position = _ref.position,
      theme = _ref.theme,
      children = _ref.children;

  var style = position.open ? { top: position.top,
    left: position.left,
    transform: 'translate(-50%) scale(1)',
    transition: 'transform 0.15s cubic-bezier(.3,1.2,.2,1)'
  } : {
    transform: 'translate(-50%) scale(0)'
  };
  return _react2.default.createElement(
    'div',
    { className: theme.toolbarStyles.toolbar,
      style: style },
    children
  );
};

var Toolbar = function (_React$Component) {
  _inherits(Toolbar, _React$Component);

  function Toolbar() {
    var _ref2;

    var _temp, _this, _ret;

    _classCallCheck(this, Toolbar);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref2 = Toolbar.__proto__ || Object.getPrototypeOf(Toolbar)).call.apply(_ref2, [this].concat(args))), _this), _this.state = {
      isVisible: false,
      position: { open: false }
    }, _this.onVisibilityChanged = function (isVisible) {
      // need to wait a tick for window.getSelection() to be accurate
      // when focusing editor with already present selection
      var _this$props$toolbarHe = _this.props.toolbarHeight,
          toolbarHeight = _this$props$toolbarHe === undefined ? DEFAULT_TOOLBAR_HEIGHT : _this$props$toolbarHe;

      setTimeout(function () {
        var position = void 0;
        if (isVisible) {
          var toolbar = (0, _reactDom.findDOMNode)(_this.toolbar);
          var relativeParent = getRelativeParent(toolbar.parentElement);
          var relativeRect = relativeParent ? relativeParent.getBoundingClientRect() : document.body.getBoundingClientRect();
          var selectionRect = (0, _draftJs.getVisibleSelectionRect)(window);
          position = {
            top: selectionRect.top - relativeRect.top - toolbarHeight,
            left: selectionRect.left - relativeRect.left + selectionRect.width / 2,
            open: true
          };
        } else {
          position = { open: false };
        }
        _this.setState({ position: position });
      }, 0);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Toolbar, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.props.store.subscribeToItem('isVisible', this.onVisibilityChanged);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.props.store.unsubscribeFromItem('isVisible', this.onVisibilityChanged);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          theme = _props.theme,
          store = _props.store,
          _props$toolbarCompone = _props.toolbarComponent,
          toolbarComponent = _props$toolbarCompone === undefined ? _react2.default.createElement(DefaultToolbarComponent, null) : _props$toolbarCompone;

      return _react2.default.cloneElement(toolbarComponent, {
        ref: function ref(toolbar) {
          _this2.toolbar = toolbar;
        },
        position: this.state.position,
        theme: theme
      }, this.props.structure.map(function (Component, index) {
        return _react2.default.createElement(Component, {
          key: index,
          theme: theme.buttonStyles,
          getEditorState: store.getItem('getEditorState'),
          setEditorState: store.getItem('setEditorState')
        });
      }));
    }
  }]);

  return Toolbar;
}(_react2.default.Component);

exports.default = Toolbar;